package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("NetworkGlobals")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class NetworkGlobals implements Marshallable {
	private Rational operatorAcceptThreshold;
	private Rational validatorAcceptThreshold;
	private String majorBlockSchedule;
	private boolean anchorEmptyBlocks;
	private FeeSchedule feeSchedule;
	private NetworkLimits limits;

    //
	public Rational getOperatorAcceptThreshold() {
	    return operatorAcceptThreshold;
	}
	public void setOperatorAcceptThreshold(final Rational value) {
	    this.operatorAcceptThreshold = value;
	}

	public NetworkGlobals operatorAcceptThreshold(final Rational value) {
	    setOperatorAcceptThreshold(value);
	    return this;
	}
	public Rational getValidatorAcceptThreshold() {
	    return validatorAcceptThreshold;
	}
	public void setValidatorAcceptThreshold(final Rational value) {
	    this.validatorAcceptThreshold = value;
	}

	public NetworkGlobals validatorAcceptThreshold(final Rational value) {
	    setValidatorAcceptThreshold(value);
	    return this;
	}
	public String getMajorBlockSchedule() {
	    return majorBlockSchedule;
	}
	public void setMajorBlockSchedule(final String value) {
	    this.majorBlockSchedule = value;
	}

	public NetworkGlobals majorBlockSchedule(final String value) {
	    setMajorBlockSchedule(value);
	    return this;
	}
	public boolean getAnchorEmptyBlocks() {
	    return anchorEmptyBlocks;
	}
	public void setAnchorEmptyBlocks(final boolean value) {
	    this.anchorEmptyBlocks = value;
	}

	public NetworkGlobals anchorEmptyBlocks(final boolean value) {
	    setAnchorEmptyBlocks(value);
	    return this;
	}
	public FeeSchedule getFeeSchedule() {
	    return feeSchedule;
	}
	public void setFeeSchedule(final FeeSchedule value) {
	    this.feeSchedule = value;
	}

	public NetworkGlobals feeSchedule(final FeeSchedule value) {
	    setFeeSchedule(value);
	    return this;
	}
	public NetworkLimits getLimits() {
	    return limits;
	}
	public void setLimits(final NetworkLimits value) {
	    this.limits = value;
	}

	public NetworkGlobals limits(final NetworkLimits value) {
	    setLimits(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.operatorAcceptThreshold == null)) {
            marshaller.writeValue(1, operatorAcceptThreshold);
        }
        if (!(this.validatorAcceptThreshold == null)) {
            marshaller.writeValue(2, validatorAcceptThreshold);
        }
        if (!(this.majorBlockSchedule == null || this.majorBlockSchedule.length() == 0)) {
            marshaller.writeString(3, this.majorBlockSchedule);
        }
        if (!(!this.anchorEmptyBlocks)) {
            marshaller.writeBool(4, this.anchorEmptyBlocks);
        }
        if (!(this.feeSchedule == null)) {
            marshaller.writeValue(5, feeSchedule);
        }
        if (!(this.limits == null)) {
            marshaller.writeValue(6, limits);
        }
        return marshaller.array();
    }
}
